# Google App State API . states

## Instance Methods

Clears (sets to empty) the data for the passed key if and only if the passed version matches the currently stored version. This method results in a conflict error on version mismatch.

Deletes a key and the data associated with it. The key is removed and no longer counts against the key quota. Note that since this method is not safe in the face of concurrent modifications, it should only be used for development and testing purposes. Invoking this method in shipping code can result in data loss and data corruption.

Retrieves the data corresponding to the passed key. If the key does not exist on the server, an HTTP 404 will be returned.

Lists all the states keys, and optionally the state data.

Update the data associated with the input key if and only if the passed version matches the currently stored version. This method is safe in the face of concurrent writes. Maximum per-key size is 128KB.

### Method Details

`clear(stateKey, currentDataVersion=None)`

    Clears (sets to empty) the data for the passed key if and only if the passed version matches the currently stored version. This method results in a conflict error on version mismatch.

    Args:
      stateKey: integer, The key for the data to be retrieved. (required)
      currentDataVersion: string, The version of the data to be cleared. Version strings are returned by the server.

    Returns:
      An object of the form:

        { # This is a JSON template for an app state write result.
        "kind": "appstate#writeResult", # Uniquely identifies the type of this resource. Value is always the fixed string appstate#writeResult.
        "stateKey": 42, # The written key.
        "currentStateVersion": "A String", # The version of the data for this key on the server.
      }

`delete(stateKey)`

    Deletes a key and the data associated with it. The key is removed and no longer counts against the key quota. Note that since this method is not safe in the face of concurrent modifications, it should only be used for development and testing purposes. Invoking this method in shipping code can result in data loss and data corruption.

    Args:
      stateKey: integer, The key for the data to be retrieved. (required)

`get(stateKey)`

    Retrieves the data corresponding to the passed key. If the key does not exist on the server, an HTTP 404 will be returned.

    Args:
      stateKey: integer, The key for the data to be retrieved. (required)

    Returns:
      An object of the form:

        { # This is a JSON template for an app state resource.
        "stateKey": 42, # The key for the data.
        "kind": "appstate#getResponse", # Uniquely identifies the type of this resource. Value is always the fixed string appstate#getResponse.
        "data": "A String", # The requested data.
        "currentStateVersion": "A String", # The current app state version.
      }

`list(includeData=None)`

    Lists all the states keys, and optionally the state data.

    Args:
      includeData: boolean, Whether to include the full data in addition to the version number

    Returns:
      An object of the form:

        { # This is a JSON template to convert a list-response for app state.
        "items": [ # The app state data.
          { # This is a JSON template for an app state resource.
            "stateKey": 42, # The key for the data.
            "kind": "appstate#getResponse", # Uniquely identifies the type of this resource. Value is always the fixed string appstate#getResponse.
            "data": "A String", # The requested data.
            "currentStateVersion": "A String", # The current app state version.
          },
        ],
        "kind": "appstate#listResponse", # Uniquely identifies the type of this resource. Value is always the fixed string appstate#listResponse.
        "maximumKeyCount": 42, # The maximum number of keys allowed for this user.
      }

`update(stateKey, body, currentStateVersion=None)`

    Update the data associated with the input key if and only if the passed version matches the currently stored version. This method is safe in the face of concurrent writes. Maximum per-key size is 128KB.

    Args:
      stateKey: integer, The key for the data to be retrieved. (required)
      body: object, The request body. (required)
        The object takes the form of:

    { # This is a JSON template for a requests which update app state
        "kind": "appstate#updateRequest", # Uniquely identifies the type of this resource. Value is always the fixed string appstate#updateRequest.
        "data": "A String", # The new app state data that your application is trying to update with.
      }

      currentStateVersion: string, The version of the app state your application is attempting to update. If this does not match the current version, this method will return a conflict error. If there is no data stored on the server for this key, the update will succeed irrespective of the value of this parameter.

    Returns:
      An object of the form:

        { # This is a JSON template for an app state write result.
        "kind": "appstate#writeResult", # Uniquely identifies the type of this resource. Value is always the fixed string appstate#writeResult.
        "stateKey": 42, # The written key.
        "currentStateVersion": "A String", # The version of the data for this key on the server.
      }